﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace TestCustomZoomLevels
{
    public partial class frmMainDisplay : Form
    {
        public frmMainDisplay()
        {
            InitializeComponent();
        }

        private void frmMainDisplay_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;
            winformsMap1.CurrentExtent = ExtentHelper.GetDrawingExtent(new RectangleShape(-97.7612400054933, 30.2895641326905, -97.729482650757, 30.2669048309327), winformsMap1.Width, winformsMap1.Height);
            winformsMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.FromArgb(255, 233, 232, 214));

            ShapeFileFeatureLayer featureLayer = new ShapeFileFeatureLayer(@"C:\Program Files (x86)\ThinkGeo\Map Suite Web Full Edition 4.0\Samples\CSharp Samples\SampleData\USA\Austin\Austinstreets.shp", ShapeFileReadWriteMode.ReadOnly);

            featureLayer.Open();
            RectangleShape bounds = featureLayer.GetBoundingBox();
            featureLayer.Close();

            SyncZoomLevels(featureLayer);
            winformsMap1.ZoomLevelSnapping = ZoomLevelSnappingMode.SnapUp;

            featureLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.LocalRoad2;
            featureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay staticOverlay = new LayerOverlay();
            staticOverlay.Layers.Add("AustinStreets", featureLayer);
            winformsMap1.Overlays.Add("StreetsOverlay", staticOverlay);

            winformsMap1.Refresh();

        }

        private void SyncZoomLevels(ShapeFileFeatureLayer layer)
        {
            layer.ZoomLevelSet.ZoomLevel01.Scale = 500000.0;
            layer.ZoomLevelSet.ZoomLevel01.Name = "1";
            layer.ZoomLevelSet.ZoomLevel02.Scale = 319365.0;
            layer.ZoomLevelSet.ZoomLevel02.Name = "2";
            layer.ZoomLevelSet.ZoomLevel03.Scale = 203988.0;
            layer.ZoomLevelSet.ZoomLevel03.Name = "3";
            layer.ZoomLevelSet.ZoomLevel04.Scale = 130293.0;
            layer.ZoomLevelSet.ZoomLevel04.Name = "4";
            layer.ZoomLevelSet.ZoomLevel05.Scale = 83222.0;
            layer.ZoomLevelSet.ZoomLevel05.Name = "5";
            layer.ZoomLevelSet.ZoomLevel06.Scale = 53157.0;
            layer.ZoomLevelSet.ZoomLevel06.Name = "6";
            layer.ZoomLevelSet.ZoomLevel07.Scale = 33953.0;
            layer.ZoomLevelSet.ZoomLevel07.Name = "1";
            layer.ZoomLevelSet.ZoomLevel08.Scale = 21687.0;
            layer.ZoomLevelSet.ZoomLevel08.Name = "8";
            layer.ZoomLevelSet.ZoomLevel09.Scale = 13852.0;
            layer.ZoomLevelSet.ZoomLevel09.Name = "9";
            layer.ZoomLevelSet.ZoomLevel10.Scale = 8848.0;
            layer.ZoomLevelSet.ZoomLevel10.Name = "10";
            layer.ZoomLevelSet.ZoomLevel11.Scale = 5651.0;
            layer.ZoomLevelSet.ZoomLevel11.Name = "11";
            layer.ZoomLevelSet.ZoomLevel12.Scale = 3610.0;
            layer.ZoomLevelSet.ZoomLevel12.Name = "12";
            layer.ZoomLevelSet.ZoomLevel13.Scale = 2306.0;
            layer.ZoomLevelSet.ZoomLevel13.Name = "13";
            layer.ZoomLevelSet.ZoomLevel14.Scale = 1473.0;
            layer.ZoomLevelSet.ZoomLevel14.Name = "14";
            layer.ZoomLevelSet.ZoomLevel15.Scale = 941.0;
            layer.ZoomLevelSet.ZoomLevel15.Name = "15";
            layer.ZoomLevelSet.ZoomLevel16.Scale = 601.0;
            layer.ZoomLevelSet.ZoomLevel16.Name = "16";
            layer.ZoomLevelSet.ZoomLevel17.Scale = 384.0;
            layer.ZoomLevelSet.ZoomLevel17.Name = "17";
            layer.ZoomLevelSet.ZoomLevel18.Scale = 245.0;
            layer.ZoomLevelSet.ZoomLevel18.Name = "18";
            layer.ZoomLevelSet.ZoomLevel19.Scale = 157.0;
            layer.ZoomLevelSet.ZoomLevel19.Name = "19";
            layer.ZoomLevelSet.ZoomLevel20.Scale = 100.0;
            layer.ZoomLevelSet.ZoomLevel20.Name = "20";
        }

        private void winformsMap1_CurrentExtentChanged(object sender, CurrentExtentChangedWinformsMapEventArgs e)
        {
            //ZoomLevel level = winformsMap1.ZoomLevelSet.GetZoomLevel(winformsMap1.CurrentExtent, winformsMap1.Width, winformsMap1.MapUnit); //GetCurrentZoomLevel(winformsMap1.CurrentScale).ToString();
            //textBox1.Text = level.Scale.ToString();
        }


        private int GetCurrentZoomLevel(double scale)
        {
            int ReturnValue = -1;
            if (winformsMap1.ZoomLevelSet.CustomZoomLevels.Count > 0)
            {
                for (int looper = 0; looper < 20; looper++)
                {
                    if (Math.Abs(winformsMap1.ZoomLevelSet.CustomZoomLevels[looper].Scale - scale) < .01)
                        ReturnValue = looper + 1;
                }
            }
            return ReturnValue;
        }

    }
}
